#include "Ball.h"

void Ball::setR(double const& newR, bool const& conservMassV){
	if(conservMassV){
		setM(getMv()* (PI*pow(newR,3)*4/3) );
	}
	r=newR;
}

void Ball::setM(double const& newM, bool const& conservMassV){
	if(conservMassV){
		setR( pow((3/(4*PI))*(getMv() * newM),1/3 ) );//!COMPLETER
	}
	m=newM;
}

double Ball::getR() const{return r;}
double Ball::getVolume() const {return ((PI*(pow(getR(),3))*4.)/3.);}
double Ball::getMv() const{return getM()/getVolume();}

Vect Ball::supportPoint (Vect const& direction){
	return getX() + getR()*(direction.normalize());
}

void Ball::merge(Ball const& b){
	if(((*this).getX()-b.getX())||false < pow((*this).getR()+b.getR(),2) ){//si les balles se traversent
		//celui qui a le plus grand volume absorbe
		if((*this).getR()>b.getR()){
			//(*this).setR();
			//(*this).setM();
			//b.setR();
			//b.setM();
		}
	}
}



ostream& Ball::cdisp(ostream& out){
	out<<"-----BALL-----"<<endl;
	Obj::cdisp(out);
	out<<"r    : "<<r<<endl;
	out<<"mv   : "<<(*this).getMv()<<endl;
	out<<"--------------"<<endl;
	return out;
}

void Ball::disp(vector<bool> options){
	glMatrixMode(GL_MODELVIEW);

	Obj::disp(options);

	//if(showPath)dispPath(); DANS LE DISPLAY de Obj

	glPushMatrix();
	glTranslated(getX().get(0), getX().get(1), getX().get(2));
	glRotated((getAng()||true)*180/PI,getAng().get(0), getAng().get(1), getAng().get(2));
		glLineWidth(1.0);
		GLUquadric* sphere(gluNewQuadric());

		GLfloat mat_ambient[] = { 0.7F,0.7F,0.7F,1.0F };
		GLfloat mat_ambient_color[] = { 0.8F,0.8F,0.2F,1.0F };
		GLfloat mat_diffuse[] = { 1,1,0,1 };
		GLfloat mat_specular[] = { 1,.6,.6,1 };
		GLfloat shininess[] = { 100.0 };
		GLfloat mat_emission[] = {0.05,0.05,0.,0.};
		if(options[2]){
			for(int i=0;i<4;i++){
				mat_ambient[i] = (float)rand(0,1);
				mat_ambient_color[i] = (float)rand(0,1);
				mat_diffuse[i] = (float)rand(0,1);
				mat_emission[i] = (float)rand(0,1);
			}
			shininess[0] = { 200.0 };
		}

		if(collision) {//glColor4d(1.,0.5,0.0,1.);
			mat_emission[0] = .3;
		}
		//else glColor4d(.7,.7,0.,1.);//glColor4d(rand(0,1),rand(0,1),rand(0,1),1.);//
		
		//gluSphere(sphere,getR()*0.999,10,10);
		
		//gluQuadricDrawStyle(sphere, GLU_LINE);
		//glColor4d(0.2,0.2,0.,1.);
		
		//glMaterialfv(GL_FRONT,GL_AMBIENT,mat_ambient_color);
		glMaterialfv(GL_FRONT,GL_DIFFUSE,mat_diffuse);
		glMaterialfv(GL_FRONT,GL_SPECULAR,mat_specular);
		glMaterialfv(GL_FRONT,GL_SHININESS,shininess);
		glMaterialfv(GL_FRONT,GL_EMISSION,mat_emission);

		if(options[1])gluSphere(sphere,getR()*.999,10,8);

		glLineWidth(3.0);
		//GLfloat mat_diffuse2[] = { .95,.95,0,1 };
		GLfloat mat_diffuse2[] = { .5,.5,0,1 };
		glMaterialfv(GL_FRONT,GL_DIFFUSE,mat_diffuse2);
		gluQuadricDrawStyle(sphere, GLU_LINE);
		gluSphere(sphere,getR(),10,8);
		gluDeleteQuadric(sphere);

	glPopMatrix();
}

//CONSTR----
Ball::Ball(Vect const& x,double const& rayon,double const& mass,Vect const& dx):
		Obj(x,mass,dx),r(rayon){
			i=Matrix(3,2*mass*rayon*rayon/5);
			enableRotationForce(true);
		}



BallCG::BallCG(set<Obj*> & tabObj,set<ObjC*> & tabCharg,Vect const& x,double const& mass,double const& rayon,double const& charg,Vect const& dx):
	Obj(x,mass,dx),Ball(x,rayon,mass),
	ObjCG(tabObj,tabCharg,x,mass,charg)
	{}

	
ostream& BallCG::cdisp(ostream& out){
	return Ball::cdisp(out);
}
	
void BallCG::disp(vector<bool> options){
	Ball::disp(options);
}

