#include "Camera.h"


double hyperbolicLimit(double const& nb,double const& limit){
	return (nb*limit)/sqrt(limit*limit+nb*nb);
}

void Camera::setmAspectRatio(double nb){mAspectRatio=nb;}

void Camera::look(){
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

	Vect direction({cos(-phi/360*2*PI),sin(-phi/360*2*PI),0});//pour projeter la vitesse sur l'axe de deplacement pour effet de perspective
	double vitAvant(getdx()*direction);
	gluPerspective(mFOV-hyperbolicLimit(vitAvant*500,60), mAspectRatio, mNearClippingDistance, mFarClippingDistance);
	gluLookAt(
	0,0,0,//pos
	1,0,0,//pt vis
	0,0,1);//up


	//----------------------------------------------------LIGHT
	//float ambientLight[] = { 0.7, 0.2, 0.2, 1.0 };
	float ambientLight[] = { 0.0, 0.0, 0.0, 1.0 };
	float diffuseLight[] = { 0.8, 0.8, 0.8, 1.0 };
	float specularLight[] = { 1, 1, 1, 1.0 };
	
	/*Vect posD = rotationMatrix(-rho/180*PI,1,0,0)*rotationMatrix(theta/180*PI, 0.0, 1.0, 0.0)*rotationMatrix(-phi/180*PI, 0.0, 0.0, 1.0)*Vect({.2,-.1,.1});
	//RHO
	//THETA;
	//PHI;	

	float position[] = { (float)(getX().get(0) - posD.get(0)), (float)(getX().get(1) - posD.get(1)),(float)(getX().get(2) - posD.get(2)),-1};//(float)getX().get(1), (float)getX().get(2), 1.0 };
	*/float position[] = { (float)( posLIGHT.get(0)), (float)(posLIGHT.get(1)),(float)( posLIGHT.get(2)),-1};//(float)getX().get(1), (float)getX().get(2), 1.0 };

	
	//glLightfv(GL_LIGHT0, GL_AMBIENT, ambientLight);
	//glLightfv(GL_LIGHT0, GL_DIFFUSE, diffuseLight);
	//glLightfv(GL_LIGHT0, GL_SPECULAR, specularLight);
	glLightfv(GL_LIGHT0, GL_POSITION, position);
	//--------------------------------------------------
	
	glPushMatrix();
		glRotated(rho,1,0,0);
		glRotated(theta, 0.0, 1.0, 0.0);
		glRotated(phi, 0.0, 0.0, 1.0);
		dispInterface();
	glPopMatrix();

	//dessine le pt vis
	//glColor4d(1.,1.,0.,1.);
	GLfloat mat_ambient[] = { 0.7F,0.7F,0.7F,1.0F };
	GLfloat mat_ambient_color[] = { 0.8F,0.8F,0.2F,1.0F };
	GLfloat mat_diffuse[] = { 1,1,0,1 };
	GLfloat mat_specular[] = { 1,.6,.6,1 };
	GLfloat shininess[] = { 100.0 };
	GLfloat mat_emission[] = {.3,.3,0.02,1.};
	glMaterialfv(GL_FRONT,GL_DIFFUSE,mat_diffuse);
	glMaterialfv(GL_FRONT,GL_SPECULAR,mat_specular);
	glMaterialfv(GL_FRONT,GL_SHININESS,shininess);
	glMaterialfv(GL_FRONT,GL_EMISSION,mat_emission);

	glPointSize(2.);
	glBegin(GL_POINTS);
		glVertex3d(.05,.003,0);
		glVertex3d(.05,-.003,0);	glVertex3d(.05,0,0);	glVertex3d(.05,0,.003);
		glVertex3d(.05,0,-.003);
	glEnd();
	
	/*//dessine un fond transparent pour effet ghost
	glColor4d(0.03, 0.16, 0.18, motionBlur);//couleur fond
	glBegin(GL_QUADS);
		glVertex3d(500,-10000,-10000);
		glVertex3d(500,-10000,10000);
		glVertex3d(500,10000,10000);
		glVertex3d(500,10000,-10000);
	glEnd();
	*/
	glRotated(rho,1,0,0);
	glRotated(theta, 0.0, 1.0, 0.0);
	glRotated(phi, 0.0, 0.0, 1.0);
	
	glTranslated(getX().get(0), getX().get(1), getX().get(2));//*/
	//repere
	dispRepere();

	if(follow!=NULL){
		Vect followX=follow->getX();
		Vect followdx=follow->getdx();
		gluLookAt(
		followX.get(0),followX.get(1),followX.get(2),//pos
		followX.get(0)-followdx.get(0),followX.get(1)-followdx.get(1),followX.get(2)-followdx.get(2),//pt vis
		0,0,1);//up
	}


}
void Camera::init(){ddtheta=0;ddphi=0;ddrho=0;w=Vect(3);s=Vect(3);q=Vect(3);}
void Camera::RotateTheta(GLdouble deg){ddtheta += deg;}
void Camera::RotatePhi(GLdouble deg){ddphi += deg;}
void Camera::RotateRho(GLdouble deg){ddrho += deg;}
void Camera::RotateThetaMouse(GLdouble deg){dtheta = deg;}
void Camera::RotatePhiMouse(GLdouble deg){dphi = deg;}
void Camera::RotateRhoMouse(GLdouble deg){drho = deg;}
void Camera::walk(double const& nb){w+=Vect({nb,0,0});}
void Camera::strafe(double const& nb){s+=Vect({0,nb,0});}
void Camera::jump(double const& nb){q+=Vect({0,0,nb});}
void Camera::focusMove(double const& var){mConvergence*=var;if(mConvergence==0)mConvergence=.01;}//dmConvergence*=var;}
void Camera::perspectiveMove(double const& var){dmFOV=var;}
void Camera::motionBlurMove(double const& var){dmotionBlur=var;}
double Camera::getMotionBlur(){return motionBlur;}
void Camera::message(string const& str, double disptime){
	messageTimeCount=disptime;
	messagestr=str;
}
double Camera::getPerspective(){return mFOV;}
double Camera::getFocus(){return mConvergence;}
int Camera::getCompassState(){return showBoussole;}



void Camera::update(double deltaT){

	//double deltaT(integ->getdt());

	//setT((getdx()||false)*100); // EFFET TREMBLEMENT
	dtheta+=ddtheta*deltaT/25 -.3*dtheta;
	theta+= dtheta * deltaT/10;
	while(theta<-3600)theta+=1800;
	while(theta>3600)theta-=1800;
	
	dphi+=ddphi*deltaT/25 - .3*dphi;
	phi+= dphi*deltaT/10;
	while(phi<-3600)phi+=1800;
	while(phi>3600)phi-=1800;
	
	drho+=ddrho*deltaT/25 - .7*drho - .05*rho;
	rho+= drho*deltaT/10;
	while(rho<-3600)rho+=1800;
	while(rho>3600)rho-=1800;
	
	messageTimeCount-=deltaT;

	mConvergence+=dmConvergence*deltaT;
	mFOV+=dmFOV*deltaT;
	motionBlur+=dmotionBlur*deltaT;

	posLIGHT=(29*posLIGHT+getX())/30;

	Vect forceTot(3);
	forceTot+=Vect({w.get(0)*cos(-phi/360*2*PI),w.get(0)*sin(-phi/360*2*PI),0});
	forceTot+=Vect({s.get(1)*cos(-phi/360*2*PI+PI/2),s.get(1)*sin(-phi/360*2*PI+PI/2),0});
	forceTot+=q;
	addFObjCoord(camSpeed*fast*forceTot);
	
	double k=-.005;//coeff frottement
	addFObjCoord(getdx()*k);
	//Obj::update();
	setdx( getdx() + deltaT*getF()/getM() );
	setX( getX() + deltaT*getdx() + randVect(getT()) );


	setF(Vect(3));
}

void Camera::dispRepere(){
	glPushMatrix();
		glTranslated(0,0,-.05);
		glTranslated(-getX().get(0), -getX().get(1), -getX().get(2));
		//lglColor4d(1.,1.,0.,1.);
		glColor4d(1,1,0.5,.1);
		if(showBoussole==2){
		glLineWidth(3.);
			glBegin(GL_LINE_STRIP);
				for(int i(1),imax(6);i<imax;i++){
					glVertex3d(.1*cos(i*PI/imax/2),.1*sin(i*PI/imax/2),0);
				}
			glEnd();
			glBegin(GL_LINE_STRIP);
				for(int i(1),imax(6);i<imax;i++){
					glVertex3d(.1*cos((i+imax)*PI/imax/2),.1*sin((i+imax)*PI/imax/2),0);
				}
			glEnd();
			glBegin(GL_LINE_STRIP);
				for(int i(1),imax(6);i<imax;i++){
					glVertex3d(.1*cos((i+2*imax)*PI/imax/2),.1*sin((i+2*imax)*PI/imax/2),0);
				}
			glEnd();
			glBegin(GL_LINE_STRIP);
				for(int i(1),imax(6);i<imax;i++){
					glVertex3d(.1*cos((i+3*imax)*PI/imax/2),.1*sin((i+3*imax)*PI/imax/2),0);
				}
			glEnd();
			glBegin(GL_LINE_STRIP);//N
				glVertex3d(-.1,0,0);
				glVertex3d(-.1,0,.004);
				glVertex3d(-.1,.004,0);
				glVertex3d(-.1,.004,.004);
			glEnd();
			glBegin(GL_LINE_STRIP);//W
				glVertex3d(-.004,-.1,.004);
				glVertex3d(-.002,-.1,0);
				glVertex3d(0,-.1,.004);
				glVertex3d(.002,-.1,0);
				glVertex3d(.004,-.1,.004);
			glEnd();
			glBegin(GL_LINE_STRIP);//E
				glVertex3d(.004,.1+.004,0);
				glVertex3d(0,	.1+.004,0);
				glVertex3d(0,.1,0);
				glVertex3d(.004,	.1,0);
				glVertex3d(0,.1,0);
				glVertex3d(0,	.1-.004,0);
				glVertex3d(.004,.1-.004,0);
			glEnd();
			glBegin(GL_LINE_STRIP);//S
				glVertex3d(.1,-.002,.002);
				glVertex3d(.1,.002,.002);
				glVertex3d(.1,.002,0);
				glVertex3d(.1,-.002,0);
				glVertex3d(.1,-.002,-.002);
				glVertex3d(.1,.002,-.002);
			glEnd();
		}
		else if(showBoussole==1){
			//glBegin(GL_LINE_STRIP);
			for(int i(1),imax(64);i<imax;i++){
				glPointSize(-cos(i*8.*PI/(imax-1.))*5 + 5 + 2);
				glBegin(GL_POINTS);
				glVertex3d(.1*cos(i*2*PI/imax),.1*sin(i*2*PI/imax),0);
				glEnd();
			}
			//glEnd();
		}
	glPopMatrix();
}

void Camera::dispInterface(){
	glPushMatrix();
	
	glRotated(-phiInterface, 0.0, 0.0, 1.0);
	glRotated(-rhoInterface,1,0,0);
	glRotated(-thetaInterface, 0.0, 1.0, 0.0);
	
	rhoInterface=(2*rhoInterface+rho)/3.;// bug : les sauts sont du au replacement de rho entre -360 et 360
	thetaInterface=(2*thetaInterface+theta)/3.;
	phiInterface=(2*phiInterface+phi)/3.;

	//text style
	GLfloat mat_ambient[] = { 0.7F,0.7F,0.7F,1.0F };
	GLfloat mat_ambient_color[] = { 0.8F,0.8F,0.2F,1.0F };
	GLfloat mat_diffuse[] = { 1,1,0,1 };
	GLfloat mat_specular[] = { 1,.6,.6,1 };
	GLfloat shininess[] = { 100.0 };
	GLfloat mat_emission[] = {1,1,0.0,1.};
	glMaterialfv(GL_FRONT,GL_DIFFUSE,mat_diffuse);
	glMaterialfv(GL_FRONT,GL_SPECULAR,mat_specular);
	glMaterialfv(GL_FRONT,GL_SHININESS,shininess);
	glMaterialfv(GL_FRONT,GL_EMISSION,mat_emission);

	if(showTerminal){
		
		if(panelBackground==1){
				glPointSize(50.);
				glBegin(GL_POINTS);
					glVertex3d(.1,.08,.06);
				glEnd();
				glPointSize(2.);
		}else if(panelBackground==2){
			glPointSize(50.);
				glBegin(GL_POINTS);
					glVertex3d(.1,-.08,.06);
				glEnd();
				glPointSize(2.);
		}
	} 
	
	//glColor4d(1,1,0.5,.3);
	glLineWidth(2);

	if(messageTimeCount>0){
		String3d(messagestr,-.10,10,-.3).disp();
	}

	if(!showTerminal){
		String3d title("-tab=term-",.15,10,-.3);
		title.disp();
		glPopMatrix();
		return;
	}
	String3d left(leftPanelstr,.2,55,0);
	String3d right(rightPanelstr,.2,-17.5,0);
	String3d title(titlestr,.15,10,-.3);
	
	left.disp();
	right.disp();
	title.disp();
	glPopMatrix();
}
void Camera::setLeftPanel(string const& str){leftPanelstr=str;}
void Camera::setRightPanel(string const& str){rightPanelstr=str;}
void Camera::setTitle(string const& str){titlestr=str;}

void Camera::PanelBackground(int i){panelBackground= i;}

void Camera::ApplyLeftFrustum(){
	glMatrixMode(GL_PROJECTION);
	glTranslated(-getX().get(0), -getX().get(1), -getX().get(2));
	glRotated(-phi, 0.0, 0.0, 1.0);
	glRotated(-theta, 0.0, 1.0, 0.0);
	glRotated(-rho,1,0,0);
	
	glTranslated(mConvergence,0,0);
	glRotated( -180/PI*atan(mEyeSeparation/mConvergence),0,0,1);
	glTranslated(-mConvergence,0,0);
	
	glRotated(rho,1,0,0);
	glRotated(theta, 0.0, 1.0, 0.0);
	glRotated(phi, 0.0, 0.0, 1.0);
	glTranslated(getX().get(0), getX().get(1), getX().get(2));
}
void Camera::ApplyRightFrustum(){
	glMatrixMode(GL_PROJECTION);
	glTranslated(-getX().get(0), -getX().get(1), -getX().get(2));
	glRotated(-phi, 0.0, 0.0, 1.0);
	glRotated(-theta, 0.0, 1.0, 0.0);
	glRotated(-rho,1,0,0);
	
	glTranslated(mConvergence,0,0);
	glRotated( 2*180/PI*atan(mEyeSeparation/mConvergence),0,0,1);
	glTranslated(-mConvergence,0,0);
	
	glRotated(rho,1,0,0);
	glRotated(theta, 0.0, 1.0, 0.0);
	glRotated(phi, 0.0, 0.0, 1.0);
	glTranslated(getX().get(0), getX().get(1), getX().get(2));
}

void Camera::setFollow(Obj& o){
	setX({0,0,0});
	follow=&o;
}
void Camera::setFollow(){
	//setX({0,0,0});
	follow=NULL;
}


//CONSTR---

Camera::Camera():Obj(Vect(3),1,Vect(3),Vect(3)),posLIGHT(Vect(3)),follow(NULL),camSpeed(.00001),
				showBoussole(1),showTerminal(false),
				theta(0),dtheta(0),ddtheta(0),
				phi(0),dphi(0),ddphi(0),
				rho(0),drho(0),ddrho(0),
				thetaInterface(0),phiInterface(0),rhoInterface(0),
				/*motionBlur(0.65)*/motionBlur(0.35),dmotionBlur(0),
				dmConvergence(0),
				mConvergence(1000),mEyeSeparation(.1),//STEREO
				mAspectRatio(16./9),mFOV(90),dmFOV(0),mNearClippingDistance(0.01),mFarClippingDistance(1000.){
					messageTimeCount=0;
					panelBackground=0;
				}

