#include "Integrator.h"


Integrator::Integrator(double newdt):t(0),dt(newdt){}

void Integrator::setdt(double newdt){dt=newdt;}
void Integrator::updateTime(){t+=dt;}
double Integrator::getdt(){return dt;}
void Integrator::changePhase(){phase=!phase;}
bool Integrator::getPhase(){return phase;}

//===========================================================================
//===========================================================================
IntegratorEulersymplectic::IntegratorEulersymplectic(double newdt):Integrator(newdt){}

void IntegratorEulersymplectic::integ(Vect& x, Vect& dx,Vect ddx){
	dx+=dt * ddx;
	x+=dt * dx;
}


//===========================================================================
//===========================================================================
IntegratorVelocityVerlet::IntegratorVelocityVerlet(double newdt):Integrator(newdt){}

void IntegratorVelocityVerlet::integ(Vect& x, Vect& dx,Vect ddx){
	if(phase){
		dx  += (0.5 * dt) * ddx;
  	x += dt * dx; 
	}else	dx += (0.5 * dt) * ddx;
}