#ifndef PRJ_INTEG_H
#define PRJ_INTEG_H

#include "Vect.h"

using namespace std;

class Integrator{
public:
	Integrator(double dt);
	void setdt(double dt);
	double getdt();
	virtual void integ( Vect& x, Vect& dx,Vect ddx)=0;
	void changePhase();// pour Velocity
	bool getPhase();
	void updateTime();
protected:
	double t;
	double dt;
	bool phase;
};





class IntegratorEulersymplectic : public Integrator{
public:
	IntegratorEulersymplectic(double dt);
	void integ(Vect& x, Vect& dx,Vect ddx);
};

class IntegratorVelocityVerlet: public Integrator{
public:
	IntegratorVelocityVerlet(double dt);
	void integ(Vect& x, Vect& dx,Vect ddx);
};








#endif //PRJ_INTEG_H
