#ifndef PRJ_MATRIX_H
#define PRJ_MATRIX_H

#include "Vect.h"
class Matrix {
protected:
	bool invUpToDate;
	vector<vector<double> > comp;
	vector<vector<double> > inv;
public:
	vector<vector<double > > convertTab();
	double get(size_t const& i,size_t const& j) const;//ecrit
	void set(size_t const& i, size_t const& j,double const& nb);//ecrit
	//void setDim(size_t const& i, size_t const& j);//!A ECRIRE
	size_t getDimi() const;//ecrit
	size_t getDimj() const;//ecrit

	Matrix operator*(double const&)const;//ecrit
	Matrix& operator*=(double const&);//ecrit
	friend Matrix operator*(double const&, Matrix const&);//ecrit
	friend Matrix& operator*=(double const&, Matrix&);//ecrit

	//inverser
	Matrix getInv() ;
	bool updateInv();
	//det
	double det(size_t const& j=0) const;
	Matrix min(size_t const& i, size_t const& j) const ;//enlve ligne i colonne j
	//prod Matriciel
	Matrix operator*(Matrix const&) const;
	Matrix& operator*=(Matrix const&);

	Vect operator*(Vect const&) const;

	friend Matrix operator*(Vect const&,Matrix const&);

	//add
	Matrix operator+(Matrix const&) const;
	Matrix& operator+=(Matrix const&);
	//sub
	Matrix operator-(Matrix const&) const;
	Matrix& operator-=(Matrix const&);
	//oppose
	Matrix operator-()const;
	//egalite
	bool operator==(Matrix const&)const;

	//disp
	ostream& disp(ostream& out) const;
	friend ostream& operator<<(ostream& out, Matrix const& m);

	Matrix transpose() const;


	//CONSTR----
	Matrix(size_t const& i,size_t const& j, double const& nb);
	Matrix(size_t const& i=0);

	Matrix(vector<vector<double> > const& m);
	//Matrix(initializer_list<initializer_list<double> > const& m);
	Matrix(size_t const& i, double const& nb);

};


Matrix rotationMatrix(double theta,double x,double y,double z);

#endif //PRJ_MATRIX_H
