#include "Obj.h"

void Obj::addM(Vect const& df,Vect const& dfPos){mf+=(dfPos^df);}
Vect Obj::getAng() const{return ang;}
Vect Obj::getVitAng() {return i.getInv()*mcin;}
Vect Obj::getMCin() const{return mcin;}
Vect Obj::getMf() const{return mf;}

void Obj::setAng(Vect const& v){ang=v;}
void Obj::setMCin(Vect const& v){mcin=v;}
void Obj::setMf(Vect const& v){mf=v;}
void Obj::setT(double const& newT){temp=newT;}
double Obj::getT() const{return temp;}
double Obj::getVolume() const{return 0;}
Vect Obj::getAcc(){return f/m;}

void Obj::enableTranslationForce(bool b){forceTranslate=b;}
void Obj::enableRotationForce(bool b){forceRotate=b;}

Matrix Obj::rotateMatrix(bool const& inverse){//RELATIF -> ABSOLU , true=> inverse
	Matrix result(3,1);//matrix id

	double theta=(getAng()||true);
	if (inverse) theta= -theta;
	double c=cos(theta);
	double s=sin(theta);
	Vect angNormalized=ang.normalize();
	double x(angNormalized.get(0)),y(angNormalized.get(1)),z(angNormalized.get(2));

/**/
	result.set(0,0, x*x + (1-x*x)*c );
	result.set(0,1, x*y*(1-c) - z*s);
	result.set(0,2, x*z*(1-c) + y*s);

	result.set(1,0, x*y*(1-c) + z*s);
	result.set(1,1, y*y + (1-y*y)*c);
	result.set(1,2, y*z*(1-c) - x*s);

	result.set(2,0, x*z*(1-c) - y*s);
	result.set(2,1, y*z*(1-c) + x*s);
	result.set(2,2, z*z + (1-z*z)*c);
/*/
	result.set(0,0, c + x*x*(1-c));
	result.set(0,1, x*y*(1-c) - z*s );
	result.set(0,2, x*z*(1-c) + y*s);

	result.set(1,0, y*x*(1-c) + z*s);
	result.set(1,1, c + y*y*(1-c));
	result.set(1,2, y*z*(1-c) - x*s);

	result.set(2,0, z*x*(1-c) - y*s);
	result.set(2,1, z*y*(1-c) + x*s);
	result.set(2,2, c + z*z*(1-c));
	*/
	return result;
}

void Obj::addMf(Vect const& m){mf+=m;}

Vect Obj::convertRefRel(Vect const& v){
	//return rotateMatrix()*Vect(v) + getX();
	return rotateMatrix(true)*(Vect(v) - getX());
}

Vect Obj::convertRefAbs(Vect const& v){
	//return rotateMatrix(true)*Vect(v) - getX();
	return rotateMatrix()*Vect(v) + getX();
}

void Obj::addFWorldCoord(Vect const& df, Vect const& posAbs){
	if(forceTranslate)f+=df;
	if(forceRotate)mf+=(posAbs-getX())^df;
}

void Obj::addFObjCoord(Vect const& df, Vect const& posRel){
	if(forceTranslate)f+=df;
	if(forceRotate)mf+=(rotateMatrix()*posRel)^df;
}

void Obj::setF(Vect const& f){(*this).f=f;}
void Obj::setX(Vect const& v){x=v;}
void Obj::setdx(Vect const& v){dx=v;}
void Obj::setM(double const& newM){m=newM;}
double Obj::getR() const{return 0;}

Vect Obj::supportPoint (Vect const& direction){return getX();}

//================================================================
//================================================================
//================================================================
Integrator* Obj::integ = new IntegratorEulersymplectic(.045);
//Integrator* Obj::integ = new IntegratorVelocityVerlet(.045);
//================================================================
//================================================================
//================================================================

void Obj::update(){

	/*if(forceTranslate)  setdx( getdx() + deltaT*getF()/getM() );
	setX( getX() + deltaT*getdx() + randVect(getT()) );*/
	integ->integ( x, dx, f/m);
	x+=randVect(getT());

	double deltaT=integ->getdt();

	if(forceRotate)     setMCin( getMCin() +   deltaT*getMf() );
	setAng( getAng() + deltaT*(i.getInv())*getMCin() + randVect(getT()));
	//setAng( getAng() + deltaT*(rotateMatrix()*i.getInv()*rotateMatrix(true))*getMCin() + randVect(getT()));
	// probleme integrateur mCin et omega, utilise euler semi retrograde pour le moment
	//integ->integ( );

	if(showPath){
		path.push_back(getX());
	}
}
void Obj::init(){
	setF({0,0,0});
	setMf({0,0,0});
	collision=false;
}


double Obj::getM() const{return m;}
Vect Obj::getX() const{return x;}
Vect Obj::getdx() const{return dx;}
Vect Obj::getdxAbs(Vect const& pos)  {
	return ( getdx() + (((i.getInv())*getMCin()) ^ (pos - getX())) );
	//return v ;
}
Vect Obj::getF() const{return f;}


ostream& Obj::cdisp(ostream& out){
	out<<"--------------"<<endl;
	out<<"x    : "<<x;
	out<<"dx/dt: "<<dx;
	out<<"F    : "<<f;
	out<<"mass : "<<m<<endl;
	out<<"ang  : "<<ang;
	out<<"mcin : "<<mcin;
	out<<"ang' : "<<getVitAng();
	out<<"--------------"<<endl;
	return out;
}

void Obj::disp(vector<bool> options){

	glMatrixMode(GL_MODELVIEW);
	if(showPath)dispPath();

	if(collision){//glColor4d(1.,0.,0.,1.);
		GLfloat mat_emission[] = {1,0,0.,1.};
		glMaterialfv(GL_FRONT,GL_EMISSION,mat_emission);
	}
	else {//glColor4d(1.,1.,1.,1.);
		GLfloat mat_emission[] = {1,1,0.,1.};
		glMaterialfv(GL_FRONT,GL_EMISSION,mat_emission);
	}
	glPointSize(2.);
	glBegin(GL_POINTS);
		glVertex3d(getX().get(0), getX().get(1), getX().get(2));
	glEnd();

	//INFOS
	if(options[0]){
		glPushMatrix();
		glTranslated(getX().get(0), getX().get(1), getX().get(2));
			
			glLineWidth(2.0);

			//moment Cin (VERT-claire)
			GLfloat mat_emission2[] = {0.5,1,0.5,0.};
			glMaterialfv(GL_FRONT,GL_EMISSION,mat_emission2);
			glBegin(GL_LINES);
				glVertex3d(0,0,0);
				glVertex3d(mcin.get(0),mcin.get(1),mcin.get(2));
			glEnd();

			//moment Force (VERT)
			GLfloat mat_emission3[] = {0,1,0,0.};
			glMaterialfv(GL_FRONT,GL_EMISSION,mat_emission3);
			glBegin(GL_LINES);
				glVertex3d(0,0,0);
				glVertex3d(mf.get(0),mf.get(1),mf.get(2));
			glEnd();

			//vitesse (ROUGE-claire)
			GLfloat mat_emission4[] = {1,0.5,0.5,0.};
			glMaterialfv(GL_FRONT,GL_EMISSION,mat_emission4);
			glBegin(GL_LINES);
				glVertex3d(0,0,0);
				glVertex3d(dx.get(0),dx.get(1),dx.get(2));
			glEnd();

			//Force (ROUGE)
			GLfloat mat_emission5[] = {1,0,0.,0.};
			glMaterialfv(GL_FRONT,GL_EMISSION,mat_emission5);
			glBegin(GL_LINES);
				glVertex3d(0,0,0);
				glVertex3d(f.get(0),f.get(1),f.get(2));
			glEnd();

		glPopMatrix();
	}
	//INFO TERMINAL
	if(options[3]){
	glPushMatrix();
		glTranslated(getX().get(0), getX().get(1), getX().get(2));	
		glLineWidth(2.0);
		GLfloat mat_emission3[] = {0,1,0,0.};
		glMaterialfv(GL_FRONT,GL_EMISSION,mat_emission3);
		std::ostringstream stream;
		cdisp(stream);
		//if(getR()<2)String3d(stream.str() ,0,0,0,2).disp();else
		String3d(stream.str() ,0,0,0).disp();
	glPopMatrix();
	}

}

void Obj::dispPath(){
	glLineWidth(2.);
	//glColor4d(0.5,1.,1.,1);

		GLfloat mat_ambient[] = { 0.7F,0.7F,0.7F,1.0F };
		GLfloat mat_ambient_color[] = { 0.8F,0.8F,0.2F,1.0F };
		GLfloat mat_diffuse[] = { 1,1,0,1 };
		GLfloat mat_specular[] = { 1,.6,.6,1 };
		GLfloat shininess[] = { 10.0 };
		GLfloat mat_emission[] = {0.5,1,1,1};
		glMaterialfv(GL_FRONT,GL_DIFFUSE,mat_diffuse);
		glMaterialfv(GL_FRONT,GL_SPECULAR,mat_specular);
		glMaterialfv(GL_FRONT,GL_SHININESS,shininess);
		glMaterialfv(GL_FRONT,GL_EMISSION,mat_emission);


	glBegin(GL_LINE_STRIP);
	for(size_t i=0;i<path.size();i++){
			glVertex3d(path[i].get(0),path[i].get(1),path[i].get(2));
	}glEnd();
}


//CONSTR---
Obj::Obj(Vect const& x,double const& mass, Vect const& dx,Vect const& ang, Vect const& mcin):
	forceTranslate(true),forceRotate(true),x(x),dx(dx),m(mass),temp(0),i(3,1),ang(ang),mcin(mcin)
	{
		collision=false;
		forceRotate=false;
		showPath=false;
	}
