#include "Special.h"

#include "System.h"


Obstacle::Obstacle(set<Obj*> & mytabObj,Vect const& pos, Vect const& dim, double mass, Vect const& ang ):Obj(pos,mass,Vect(3), ang),dim(dim),tabObj(&mytabObj){

			i=Matrix(3,1.);
			i.set(0,0, m*( pow(dim.get(1),2)+pow(dim.get(2),2) )/12.);
			i.set(1,1, m*( pow(dim.get(0),2)+pow(dim.get(2),2) )/12.);
			i.set(2,2, m*( pow(dim.get(0),2)+pow(dim.get(1),2) )/12.);
			enableRotationForce(true);
}

void Obstacle::setDim(Vect const& newDim){dim=newDim;}
Vect Obstacle::getDim(){return dim;}
void Obstacle::disp(vector<bool> options){
	glMatrixMode(GL_MODELVIEW);
	Obj::disp(options);
	glMatrixMode(GL_MODELVIEW);
	
	glPushMatrix();
	glTranslated(getX().get(0), getX().get(1), getX().get(2));
	glRotated((getAng()||true)*180/PI,getAng().get(0), getAng().get(1), getAng().get(2));
	//glScaled();
	GLfloat mat_ambient[] = { 0.7F,0.7F,0.7F,1.0F };
		GLfloat mat_ambient_color[] = { 0.8F,0.8F,0.2F,1.0F };
		GLfloat mat_diffuse[] = { 1,1,0,1 };
		GLfloat mat_specular[] = { 1,.6,.6,1 };
		GLfloat shininess[] = { 100.0 };
		GLfloat mat_emission[] = {0.5,0.5,0.,0.};
		if(options[2]){
			for(int i=0;i<4;i++){
				mat_ambient[i] = (float)rand(0,1);
				mat_ambient_color[i] = (float)rand(0,1);
				mat_diffuse[i] = (float)rand(0,1);
				mat_emission[i] = (float)rand(0,1);
			}
			shininess[0] = { 200.0 };
		}
		if(collision) {mat_emission[0] = .3;}
		glMaterialfv(GL_FRONT,GL_DIFFUSE,mat_diffuse);
		glMaterialfv(GL_FRONT,GL_SPECULAR,mat_specular);
		glMaterialfv(GL_FRONT,GL_SHININESS,shininess);
		glMaterialfv(GL_FRONT,GL_EMISSION,mat_emission);

		glLineWidth(2.);
		if(collision) {
			mat_emission[0] = .3;
		}
		if(options[1]){
			glBegin(GL_QUADS);
			 glVertex3d( dim[0], dim[1],-dim[2]);
			 glVertex3d(-dim[0], dim[1],-dim[2]);
			 glVertex3d(-dim[0], dim[1], dim[2]);
				glVertex3d( dim[0], dim[1], dim[2]);
			glEnd();
			glBegin(GL_QUADS);
				glVertex3d( dim[0],-dim[1],-dim[2]);
				glVertex3d( dim[0], dim[1],-dim[2]);
				glVertex3d( dim[0], dim[1], dim[2]);
				glVertex3d( dim[0],-dim[1], dim[2]);
			glEnd();
			glBegin(GL_QUADS);
				glVertex3d( dim[0],-dim[1], dim[2]);
				glVertex3d(-dim[0],-dim[1], dim[2]);
				glVertex3d(-dim[0],-dim[1],-dim[2]);
				glVertex3d( dim[0],-dim[1],-dim[2]);
			glEnd();
			glBegin(GL_QUADS);
				glVertex3d(-dim[0],-dim[1], dim[2]);
				glVertex3d(-dim[0], dim[1], dim[2]);
				glVertex3d(-dim[0], dim[1],-dim[2]);
				glVertex3d(-dim[0],-dim[1],-dim[2]);
			glEnd();
			glBegin(GL_QUADS);
				glVertex3d( dim[0],-dim[1], dim[2]);
				glVertex3d( dim[0], dim[1], dim[2]);
				glVertex3d(-dim[0], dim[1], dim[2]);
				glVertex3d(-dim[0],-dim[1], dim[2]);
			glEnd();
			glBegin(GL_QUADS);
				glVertex3d(-dim[0],-dim[1],-dim[2]);
				glVertex3d(-dim[0], dim[1],-dim[2]);
				glVertex3d( dim[0], dim[1],-dim[2]);
				glVertex3d( dim[0],-dim[1],-dim[2]);
			glEnd();
		}
			mat_emission[0]=.25;
			mat_emission[1]=.25;
			glMaterialfv(GL_FRONT,GL_EMISSION,mat_emission);
			glBegin(GL_LINES);
				glVertex3d( dim[0], dim[1], dim[2]);
				glVertex3d(-dim[0], dim[1], dim[2]);
			glEnd();
			glBegin(GL_LINES);
				glVertex3d( dim[0], dim[1], dim[2]);
				glVertex3d( dim[0],-dim[1], dim[2]);
			glEnd();
			glBegin(GL_LINES);
				glVertex3d( dim[0], dim[1], dim[2]);
				glVertex3d( dim[0], dim[1],-dim[2]);
			glEnd();
			glBegin(GL_LINES);
				glVertex3d( dim[0], dim[1],-dim[2]);
				glVertex3d( dim[0],-dim[1],-dim[2]);
			glEnd();
			glBegin(GL_LINES);
				glVertex3d( dim[0], dim[1],-dim[2]);
				glVertex3d(-dim[0], dim[1],-dim[2]);
			glEnd();
			glBegin(GL_LINES);
				glVertex3d( dim[0],-dim[1], dim[2]);
				glVertex3d( dim[0],-dim[1],-dim[2]);
			glEnd();
			glBegin(GL_LINES);
				glVertex3d( dim[0],-dim[1], dim[2]);
				glVertex3d(-dim[0],-dim[1], dim[2]);
			glEnd();
			glBegin(GL_LINES);
				glVertex3d(-dim[0], dim[1], dim[2]);
				glVertex3d(-dim[0], dim[1],-dim[2]);
			glEnd();
			glBegin(GL_LINES);
				glVertex3d(-dim[0], dim[1], dim[2]);
				glVertex3d(-dim[0],-dim[1], dim[2]);
			glEnd();
			glBegin(GL_LINES);
				glVertex3d(-dim[0],-dim[1], dim[2]);
				glVertex3d(-dim[0],-dim[1],-dim[2]);
			glEnd();
			glBegin(GL_LINES);
				glVertex3d(-dim[0], dim[1],-dim[2]);
				glVertex3d(-dim[0],-dim[1],-dim[2]);
			glEnd();
			glBegin(GL_LINES);
				glVertex3d( dim[0],-dim[1],-dim[2]);
				glVertex3d(-dim[0],-dim[1],-dim[2]);
	glEnd();
	glPopMatrix();
}

ostream& Obstacle::cdisp(ostream& out){return Obj::cdisp(out);}

void Obstacle::force(){
	for(auto it:*tabObj){
		Vect posRel = convertRefRel(it->getX());

		//point du paral. le plus proche du centre de la sphere
		Vect v(dim.getDim());

		for(int i=0;i<dim.getDim();i++){
			if( posRel.get(i) > dim.get(i) ){
				v.set(i,dim.get(i));
			}else if( posRel.get(i) < -dim.get(i) ){
				v.set(i,-dim.get(i));
			}
			else{
				v.set(i,posRel.get(i));
			}
		}

		v = convertRefAbs(v);


		Vect direction( v-(it->getX()) );
		Vect PtSupport ( it->supportPoint(direction) );

		//if( (PtSupport-it->getX()).normeCarree() > direction.normeCarree()  ){ // si collision
		if(  (it->getX() - v ) * ( PtSupport - v) <0   ){ // si collision
			collision=true;
			
			Vect posForce = (v+PtSupport)/2. ;

			Vect ddist=it->getdxAbs( posForce ) - this->getdxAbs( posForce );
			
			Vect ffrott = 10.*ddist.reject(direction);

			it->addFWorldCoord(-ffrott,posForce);
			this->addFWorldCoord(ffrott,posForce);				
/*
			it->addFObjCoord(f);
			this->addFObjCoord(-f);


*/
			it->collision=true;
			Vect f(direction.normalize()* 1000.*(v-PtSupport).norme()  );//  +  5.*ddist.project(direction)  );
			it->addFWorldCoord( -f, posForce );
			this->addFWorldCoord( f, posForce );

		}

		//direction de l'éventuelle collision
		/*Vect direction = v-posRel;

		Vect pointLePlusEnfonce(3);

		Vect pointContact(3);

		if(direction.normeCarree()!=0){//ou alors if(v||false) , mais moins lisible 
			it->collision=true;
			pointLePlusEnfonce=it->supportPoint(direction);
			pointContact=(pointLePlusEnfonce+v)/2.;
			Vect f( direction.normalize() * (pointLePlusEnfonce-pointContact).norme() );
			f= rotateMatrix()*f;
			it->addFWorldCoord( -f, convertRefAbs(pointContact));
			this->addFWorldCoord( f , convertRefAbs(pointContact));
		}
		else {//if (direction.normeCarree()==0){
			//INTERIEUR SPHERE, A TRAITER SEPAREMENT
		}*/
	}
}






















void Ventillateur::disp(vector<bool> options){
	Ball::disp(options);
	glPushMatrix();
	glTranslated(getX().get(0), getX().get(1), getX().get(2));
	glRotated((getAng()||true)*180/PI,getAng().get(0), getAng().get(1), getAng().get(2));
			GLfloat mat_ambient[] = { 0.7F,0.7F,0.7F,1.0F };
			GLfloat mat_ambient_color[] = { 0.8F,0.8F,0.2F,1.0F };
			GLfloat mat_diffuse[] = { 1,1,0,1 };
			GLfloat mat_specular[] = { 1,.6,.6,1 };
			GLfloat shininess[] = { 100.0 };
			GLfloat mat_emission[] = {1,1,0.,0.};

			//glMaterialfv(GL_FRONT,GL_AMBIENT,mat_ambient_color);
			glMaterialfv(GL_FRONT,GL_DIFFUSE,mat_diffuse);
			glMaterialfv(GL_FRONT,GL_SPECULAR,mat_specular);
			glMaterialfv(GL_FRONT,GL_SHININESS,shininess);
			glMaterialfv(GL_FRONT,GL_EMISSION,mat_emission);

		glBegin(GL_LINE_STRIP);
			glVertex3d(0,0,0);
			glVertex3d(getR()+forceStrength,0,0);
		glEnd();
	glPopMatrix();
}
ostream& Ventillateur::cdisp(ostream& out){
	return Ball::cdisp(out);
}

Ventillateur::Ventillateur(set<Obj*>& o,Vect const& position,double mass, double rayon,double newforceStrength):Obj(position,mass),Ball(position,rayon,mass)
	{	tabObj=&o;
		forceStrength=newforceStrength;
		enableRotationForce(true);
	}

void Ventillateur::force(){
	for (auto it:(*tabObj)){
		Vect direction(getX()-it->getX());
		Vect vent = rotateMatrix()*Vect({1,0,0});
		Vect ventRejection= direction.reject(vent);

		Vect F(3);

		if(direction*vent<0){
			F+=-direction.project(vent)/(pow(direction*vent-1,2))/pow(ventRejection.norme()+1,2)-ventRejection.normalize()/(pow(direction*vent-1,4))/pow(ventRejection.norme()+1,2);
		}
		

		// 1 / norme rejecton * const = force selon nonAxe
		//(direction.reject(vent).normalize())*1./(direction.reject(vent).norme());

		// 1 / (projection*normeRejection) = force selon Axe
		//vent*1./((direction*vent)*(direction.reject(vent)).norme());

		it->addFWorldCoord(forceStrength*F,(it->supportPoint(direction)));
	}
}























/*
void Lifetime::setTimeLeft(double t){timeleft=t;}
double Lifetime::getTimeLeft(){return timeleft;}

Lifetime::Lifetime(double t):timeleft(t){}
*/
void BallLife::setTimeLeft(double t){timeleft=t;}
double BallLife::getTimeLeft(){return timeleft;}

ostream& BallLife::cdisp(ostream& out){return Ball::cdisp(out);}

BallLife::BallLife(System& myparent, double mytimeleft, Vect const& pos,double mass, double rayon,Vect const& dx):
	Obj(x,mass,dx),Ball(x,rayon,mass),
	timeleft(mytimeleft),parent(&myparent),actualR(getR()){}


void BallLife::update(){
	Ball::update();
	timeleft-=Obj::integ->getdt();
	if(timeleft<.5&& timeleft>.2)setR((1./(timeleft*5))*actualR);
	else if(timeleft<.2)setR((timeleft)*actualR);
	if(timeleft<0)parent->delObj(this);
}

void BallLife::disp(vector<bool> options){
	glMatrixMode(GL_MODELVIEW);

	Obj::disp(options);

	//if(showPath)dispPath(); DANS LE DISPLAY de Obj

	glPushMatrix();
	glTranslated(getX().get(0), getX().get(1), getX().get(2));
	glRotated((getAng()||true)*180/PI,getAng().get(0), getAng().get(1), getAng().get(2));
		glLineWidth(1.0);
		GLUquadric* sphere(gluNewQuadric());

		GLfloat mat_ambient[] = { 0.7F,0.7F,0.7F,1.0F };
		GLfloat mat_ambient_color[] = { 0.8F,0.8F,0.2F,1.0F };
		GLfloat mat_diffuse[] = { (float)timeleft,(float)timeleft,0,1 };
		GLfloat mat_specular[] = { 1,.6,.6,1 };
		GLfloat shininess[] = { 100.0 };
		double var = 1;
		if(timeleft!=0) var=1/timeleft;
		GLfloat mat_emission[] = {(float)var,0.05,0.,0.};

		if(options[2]){
			for(int i=0;i<4;i++){
				mat_ambient[i] = (float)rand(0,1);
				mat_ambient_color[i] = (float)rand(0,1);
				mat_diffuse[i] = (float)rand(0,1);
				mat_emission[i] = (float)rand(0,1);
			}
			shininess[0] = { 200.0 };
		}

		if(collision) {//glColor4d(1.,0.5,0.0,1.);
			mat_emission[0] = .3;
		}
		//else glColor4d(.7,.7,0.,1.);//glColor4d(rand(0,1),rand(0,1),rand(0,1),1.);//
		
		//gluSphere(sphere,getR()*0.999,10,10);
		
		//gluQuadricDrawStyle(sphere, GLU_LINE);
		//glColor4d(0.2,0.2,0.,1.);
		
		//glMaterialfv(GL_FRONT,GL_AMBIENT,mat_ambient_color);
		glMaterialfv(GL_FRONT,GL_DIFFUSE,mat_diffuse);
		glMaterialfv(GL_FRONT,GL_SPECULAR,mat_specular);
		glMaterialfv(GL_FRONT,GL_SHININESS,shininess);
		glMaterialfv(GL_FRONT,GL_EMISSION,mat_emission);

		if(options[1])gluSphere(sphere,getR()*.999,10,8);

		glLineWidth(3.0);
		//GLfloat mat_diffuse2[] = { .95,.95,0,1 };
		GLfloat mat_diffuse2[] = { .5,.5,0,1 };
		glMaterialfv(GL_FRONT,GL_DIFFUSE,mat_diffuse2);
		gluQuadricDrawStyle(sphere, GLU_LINE);
		gluSphere(sphere,getR(),10,8);
		gluDeleteQuadric(sphere);

	glPopMatrix();
}























void Parallelepiped::setDim(Vect const& newdim){dim=newdim;}
Vect Parallelepiped::getDim(){return dim;}
void Parallelepiped::disp(vector<bool> options){
	glPushMatrix();
	glTranslated(getX().get(0), getX().get(1), getX().get(2));
	glRotated((getAng()||true),getAng().get(0), getAng().get(1), getAng().get(2));
	//glScaled();
		glLineWidth(2.);
		glColor4d(.7,.7,0.,1);
				glBegin(GL_QUADS);
					 
					glVertex3d(1,1,1);
					glVertex3d(-1,1,1);
					glVertex3d(-1,1,-1);
					glVertex3d(1,1,-1);
					 
					glVertex3d(1,-1,1);
					glVertex3d(1,1,1);
					glVertex3d(1,1,-1);
					glVertex3d(1,-1,-1);
					 
					glVertex3d(1,-1,1);
					glVertex3d(-1,-1,1);
					glVertex3d(-1,-1,-1);
					glVertex3d(1,-1,-1);
					 
					glVertex3d(-1,-1,1);
					glVertex3d(-1,1,1);
					glVertex3d(-1,1,-1);
					glVertex3d(-1,-1,-1);
					 
					glVertex3d(1,-1,1);
					glVertex3d(1,1,1);
					glVertex3d(-1,1,1);
					glVertex3d(-1,-1,1);
					 
					glVertex3d(1,-1,-1);
					glVertex3d(1,1,-1);
					glVertex3d(-1,1,-1);
					glVertex3d(-1,-1,-1);
					 
				glEnd();
		//glColor4d(0.2,0.2,0.,.5);
	glPopMatrix();


}
ostream& Parallelepiped::cdisp(ostream& out){return Obj::cdisp(out);}




















Portal::Portal(Portal& portal,Vect const& pos, Vect const& ang, double size):
		Obj(pos,0,Vect(3),ang),link(&portal),size(size){
				enableRotationForce(false);
				enableTranslationForce(false);
		}
