#ifndef PRJ_SPECIAL_H
#define PRJ_SPECIAL_H

#include "Obj.h"
#include "Force.h"
#include "Ball.h"

class System;


class Obstacle:public Obj, public Force{
	protected:
		Vect dim;//x= , y= , z= , w= , ...
		set<Obj*> * tabObj;
	public:
		Obstacle(set<Obj*>& tabObj, Vect const& pos, Vect const& dim, double mass, Vect const& ang=Vect(3) );
		void setDim(Vect const& dim);
		Vect getDim();
		void disp(vector<bool> options);
		ostream& cdisp(ostream& out);
		void force();
};

class Ventillateur:public Ball, public Force{
public:
	Ventillateur(set<Obj*>&,Vect const& position,double mass, double rayon,double forceStrength);
	
	void force();
	void disp(vector<bool> options);
	ostream& cdisp(ostream& out);
protected:
	set<Obj*>* tabObj;
	double forceStrength;
};

/*class Lifetime{
public:
	Lifetime(double);
	void setTimeLeft(double );
	double getTimeLeft();
protected:
	double timeleft;
};*/


/*class BallLife:public Ball{
public:
	BallLife(System* parent,double timeleft,Vect const& pos,double const& mass,double const& rayon, Vect const& dx=Vect(3));
	virtual void disp(vector<bool>);
	virtual void update();
	virtual ostream& cdisp(ostream& out){return Ball::cdisp(out);}
	Ball::supportPoint;
protected:
	System* parent;
	double actualR;
public:
	void setTimeLeft(double );
	double getTimeLeft();
protected:
	double timeleft;
};*/

class BallLife:public Ball{
public:
	BallLife(System& myparent, double mytimeleft, Vect const& pos,double mass, double rayon,Vect const& dx);
	virtual void disp(vector<bool>);
	virtual void update();
	ostream& cdisp(ostream& out);
	Ball::supportPoint;
	void setTimeLeft(double );
	double getTimeLeft();
protected:
	double timeleft;
	System* parent;
	double actualR;
};


class Parallelepiped:public Obj{
	protected:
		Vect dim;//x= , y= , z= , w= , ...
	public:
		void setDim(Vect const& dim);
		Vect getDim();
		virtual void disp(vector<bool> options);
		virtual ostream& cdisp(ostream& out);
};

class ParallelepipedCG:public ObjCG{

};


class Minigun:public Obj{
	//tire des balles electriques ou non
	//paricules  dure de vie
};

class Rocket:public Obj{
	//objet qui se dsintgre en petites paricules
	//qui peut ventuellement arrter de se dgrader
	//ou exploser
};

class Bomb:public Obj{
	//explose en plein de balles avec une gtrande temperature
	//particules  dure de vie, qui peuvent aussi tre des bombes
	//avant d'exploser aussi en plus petites bombes

	//on peut faire des feux d'artifie avec (vitesse != 0)
};




class Button:public Obj{
public:

};

class Tube{
	//une entree, les objets qui passent dedans suivent un parcours particulier
};

class Portal:public Obj{
private:
	Portal* link;
	double size;//le portal est une petite surface que l'on peut traverser, norme de ang = taille du portal
		// la collision entraine un dplacement dans l'autre portal
	set<Obj*> tabObj;
public:
	Portal(Portal&,Vect const& pos, Vect const& ang, double size);
	

};

#endif