#include "Spring.h"

void Spring::force(){

	Vect direction(		obj2->convertRefAbs(attache2) - obj1->convertRefAbs(attache1)	);
	double dist=direction.norme();

	if(dist>0.001)direction/=dist;
	
	double c(0.25);
	if(amorti) c=2*sqrt(k1*(*obj1).getM()*(*obj2).getM()/((*obj1).getM()+(*obj2).getM()));
	
	double ddist=(obj2->getdx() - obj1->getdx())*direction;
	//ddist=0;
	double norm;
	if((*obj1).forceTranslate && (*obj2).forceTranslate) norm= k1*(dist-l0) + ddist* c;
	else if((*obj1).forceTranslate) norm= k1*(dist-l0) + ddist* 2*sqrt(k1*(*obj1).getM());
	else if((*obj2).forceTranslate) norm= k1*(dist-l0) + ddist* 2*sqrt(k1*(*obj2).getM());
	//double R= k1*(l0+1)*(l0+1)*(l0+1)*(l0+1);//! force maximum ARBITRAIRE
	//norm = norm*R/sqrt(norm*norm + R*R) ;//vite les divergences
	Vect f( norm*direction);//! ATTENTION OSCILLATION
	//if(norm>0){
	obj1->addFObjCoord(f,attache1);
	obj2->addFObjCoord(-f,attache2);
	//}
}

void Spring::setk1(double const& newk1){k1=newk1;}

void Spring::setL0(double const& newl0){l0=newl0;}

void Spring::setObj1(Obj& o){obj1 = &o;}

void Spring::setObj2(Obj& o){obj2 = &o;}

void Spring::disp(vector<bool> options){
	//--- FUN
	double dist( ((*obj2).getX()-(*obj1).getX())||true );//distance entre les 2 obj
	double norm( k1*(dist-l0) );
	norm = norm*1/sqrt(norm*norm + 1*1);
	
	//---
	//glColor4d(1,1,1-abs(norm),abs(norm)+.05);
	//glPointSize(2.);
	glLineWidth(2);
	
	GLfloat mat_emission[] = {1,1,0.,(float)(abs(norm)+.05)};
  glMaterialfv(GL_FRONT,GL_EMISSION,mat_emission);



	glBegin(GL_LINE_STRIP);
		Vect v1(obj1->convertRefAbs(attache1));
		Vect v2(obj2->convertRefAbs(attache2));
		glVertex3d(v1.get(0),v1.get(1),v1.get(2));//((*obj1).getX().get(0)) + ((obj1->rotateMatrix(true))*attache1).get(0),((*obj1).getX().get(1)) + ((obj1->rotateMatrix(true))*attache1).get(1),((*obj1).getX().get(2)) + ((obj1->rotateMatrix(true))*attache1).get(2));
		glVertex3d(v2.get(0),v2.get(1),v2.get(2));//((*obj2).getX().get(0)) + ((obj2->rotateMatrix(true))*attache2).get(0),((*obj2).getX().get(1)) + ((obj2->rotateMatrix(true))*attache2).get(1),((*obj2).getX().get(2)) + ((obj2->rotateMatrix(true))*attache2).get(2));
	glEnd();
}
ostream& Spring::cdisp(ostream&){}


Spring::Spring(Obj& obj1, Obj& obj2,double const& k,double const& l,Vect const& attache1,Vect const& attache2):
	obj1(&obj1),obj2(&obj2),k1(k),l0(l),attache1(attache1),attache2(attache2){amorti=false;}



//------------BREAK--------------

void SpringBreak::force(){
	double dist( ((*obj2).getX()-(*obj1).getX())||true );//distance entre les 2 obj
	double norm( k1*(dist-l0) );
	if(norm<=fmax){
		Vect f( norm* ((*obj2).getX()-(*obj1).getX()) / dist);
		(*obj1).addFObjCoord(f);
		(*obj2).addFObjCoord(-f);
	}
	else{
		breakMe();
	}
}

void SpringBreak::breakMe(){
	(*parent).delF((Spring*)this);
}

SpringBreak::SpringBreak(System& parent, Obj& obj1, Obj& obj2,double const& k,double const& l,double const& fmax):
	Spring(obj1,obj2,k,l),parent(&parent), fmax(fmax){}


//-----------------DEFORM-----------

void SpringDeform::force(){
	double dist( ((*obj2).getX()-(*obj1).getX())||true );//distance entre les 2 obj

	if(dist>distMem){//si eloignement
		if(dist>(l0+l1)){
			double norm( k1*(dist-l0) );//comprend le signe
			Vect f( norm* ((*obj2).getX()-(*obj1).getX()) / dist);
			(*obj1).addFObjCoord(f);
			(*obj2).addFObjCoord(-f);
			//f =qqch
			//l0=qqch
			//!COMPLETER
		}
		else{
			double norm( k1*(dist-l0) );//comprend le signe
			Vect f( norm* ((*obj2).getX()-(*obj1).getX()) / dist);
			(*obj1).addFObjCoord(f);
			(*obj2).addFObjCoord(-f);
		}
	}

	else{//si rapprochement
		if(dist<(l0-l1)){
			//f =qqch
			//l0=qqch
			//l0=
			//!COMPLETER
		}
		else{
			double norm( k1*(dist-l0) );//comprend le signe
			Vect f( norm* ((*obj2).getX()-(*obj1).getX()) / dist);
			(*obj1).addFObjCoord(f);
			(*obj2).addFObjCoord(-f);
		}
	}

	distMem=dist;
}


SpringDeform::SpringDeform(System& parent,Obj& obj1, Obj& obj2,double const& k1,double const& k2,double const& l1,double const& l2,double const&fmax):
	SpringBreak(parent,obj1,obj2,k1,l1,fmax), l1(l2), k2(k2){}
