#ifndef PRJ_SYSTEM_H
#define PRJ_SYSTEM_H

#include "Force.h"
#include "Spring.h"
#include "Obj.h"
#include "Ball.h"
#include "Special.h"
#include "Collision.h"
#include "Archimed.h"

#include "Disp.h"

#include <set>
#include <map>
#include <typeinfo>//dsol

using namespace std;

class System:public ObjCG{//on peut dplacer un systme
	protected:
		int scale;// n=> 1=(10^n)m
		set<Obj*> tabObj;
		//tableau dont la numerotation est un pointeur map ?  pour table de collision
		map<Obj*,map<Obj*, bool> > collisionTable;
		set<Force*> tabF;//Spring + Temp + Charg + Grav
		set<ObjC*> tabCharg;
		set<Obstacle*> tabObstacle;
		Collision collision;
		Archimed archimed;

		//vector<Spring*> tabSpring;
		set<System*> tabSys;// Il n'y  a pas de Sys dans tabObj !!!

		Vect acceleration;
		Vect elecField;
		Vect magnetField;

		set<Disp*> tabDisp;

		bool collisionSoundBoolean;
	public:
		Archimed* getArchimed();
		Collision* getCollision();
		void collisionSound(bool b);
		bool collisionBool;
		bool archimedBool;

		void clear();

		void update();

		void force();
		
		void init();

		void disp(vector<bool> options=vector<bool>(10,false));
		ostream& cdisp(ostream&);
		//add/del/mthode pour gnrer des objets dformables
		Obstacle* addObstacle(Vect const& pos, Vect const& dim, double mass, Vect const& ang=Vect(3));
		ObjCG* addObj(Vect const& pos, Vect const& vit, double mass, double const& size,bool const& grav=false, double const& charg=0,bool const& disp=true);
		Ball* addObjLife(Vect const& pos, Vect const& vit, double mass, double size,double life);
		Force* addSpringAttach(Obj& o1,Obj& o2,Vect const& attache1,Vect const& attache2,double const& k1,double const& l0,bool const& amorti);
		Force* addSpring(Obj&,Obj&,double const& k1,double const& l0,bool const& amorti=false,int const& breakDeform=0,double const& k2=0, double const& l1=0,double const& fmax=0);
		System* addSys(Vect const& pos, double const& scale);
		vector<Obj*> generate(Vect const& pos,Vect const& dim,double const& space,double const& mass,int const& meshtype=0,double const& K=100,bool const& breakable=false,double const& charg=0,bool const& dispBall=true,bool const& amorti=false,Vect const& vit=Vect(3));
		Obj* generatePendulum(Vect const& pos, double const& length, double const& mass, double const& rayon);
		vector<Obj*> generatePendulum2(Vect const& pos, double const& length, double const& mass, double const& rayon);
		vector<Obj*> generatePendulum3(Vect const& pos, double const& length, double const& mass, double const& rayon);
		Ventillateur* addVentillateur(Vect const& pos,double forceStrength=10, double mass=1,double rayon=1);

		Disp* addDisp(Disp*);
		//void addPortal(Portal& portal, Vect const& pos, Vect const& ang);
		//space = espace entre 2 boules
		//dim = longueur x, y et z
		
	void delObj(Obj* obj);
		void delF(Force* f);//spring_break


		//! void send( ???, System& s);// envoyer l'objet et ses forces dans un autre Sys
		
	double frottement;
		
		//CONSTR---
		System(int const& scale,set<Obj*> & tabObj,set<ObjC*> & tabC,Vect const& pos, Vect const& ang=Vect(3),bool const& collision=false);
		private: System(System const&)=delete;
		private: System operator=(System const&)=delete;
		public: virtual ~System();
};

#endif //PRJ_SYSTEM_H

