#ifndef PRJ_VECT_H
#define PRJ_VECT_H


#include <vector>
#include <iostream>
#include <string>
#include <cmath>
#include <initializer_list>
#include <algorithm>

using namespace std;

//--provisoire
double const PI=3.14159265358979323846;
//--

class Vect{
private:
	vector<double> comp;
	Vect prodVect(Vect const& v) const;//test
	double prodScal(Vect const& v) const;//test
	Vect oppose() const;//test
	Vect mult(double const& d) const;//test
	bool compareFast(Vect const& v) const;
public:
	Vect project(Vect const& v);
	Vect reject(Vect const&);
	//constructeurs
	Vect();//test
	Vect(size_t const& dim);//test
	Vect(initializer_list<double> const& v);//test
	Vect(vector<double> v);//test
	//Vect(double const& a,double const&b,double const&c);

	//methodes
	Vect add(Vect const& v,bool const& bigDim=true) const;
	Vect sub(Vect const& v,bool const& bigDim=true) const;
	double get(size_t const& i) const;
	void set(size_t const& i, double const& nb);//test
	void set(vector<double> const& comp);//test
	void set0();
	size_t getDim() const;//OK
	void addDim(double const& d=0);//test
	void setDim(size_t const& dim);//test
	void subDim();//test
	//!NEW
	Vect cut(size_t const& first,size_t nb_comp=0);
	//!---

	bool compare(Vect const& v,double const& tol=0.,bool const& dimInegal=false) const;
	bool compare2(Vect const& v,double const& tolNorme=0.) const;
	Vect normalize() const;
	double norme() const;//test
	double normeCarree() const;//test
	Vect operator+(Vect const& v) const;//test
	Vect operator-(Vect const& v) const;//test
	Vect& operator+=(Vect const& v);//test
	Vect& operator-=(Vect const& v);//test
	Vect operator-() const;//test
	Vect operator^(Vect const& v)const ;//test
	Vect operator*(double const& nb)const ;//test
	Vect operator/(double const& nb)const ;
	bool operator==(Vect const& v)const ;//test
	bool operator!=(Vect const& v)const;//test
	double operator*(Vect const& v)const;//test
	double operator||(bool const& sqrt)const;//test
	Vect& operator*=(double const& nb);//test
	Vect& operator/=(double const& nb);
	double operator[](size_t const& i);
};

Vect operator*(double const& a, Vect const& v);//test
//void operator*=(Vect const& a, Vect const& b);
//bool operator

ostream& operator<<(ostream&,Vect const& v);//test



#endif // PRJ_VECT_H
