#include "Universe.h"
#include "Camera.h"

class Fenetre;
class GUI : public wxApp{public:bool OnInit();};//---Nouvelle application


/*void wxWindow::WarpPointer(int x_pos, int y_pos)
{
	// We really don't move the mouse programmatically under Mac.
	int x = x_pos;
	int y = y_pos;
	DoClientToScreen(&x, &y);
	CGPoint cgpoint = CGPointMake( x, y );
	CGWarpMouseCursorPosition( cgpoint );
	// At least GTK sends a mouse moved event after WarpMouse
	// should all implementations do that, something like this?
	wxMouseEvent event(wxEVT_MOTION);
	event.m_x = x_pos;
	event.m_y = y_pos;
	wxMouseState mState = ::wxGetMouseState();

	event.m_altDown = mState.AltDown();
	event.m_controlDown = mState.ControlDown();
	event.m_leftDown = mState.LeftDown();
	event.m_middleDown = mState.MiddleDown();
	event.m_rightDown = mState.RightDown();
	event.m_metaDown = mState.MetaDown();
	event.m_shiftDown = mState.ShiftDown();

	event.SetId(GetId());
	event.SetEventObject(this);
	GetEventHandler()->ProcessEvent(event);
}*/

//---sous-fenetre de dessin OpenGL
class Vue_OpenGL : public wxGLCanvas{
public:
    Vue_OpenGL(Fenetre* parent, wxSize const& taille = wxDefaultSize, wxPoint const& position = wxDefaultPosition);
    virtual ~Vue_OpenGL() {}

    void InitOpenGL();

protected:
	Fenetre* parent;
    void dessine(wxPaintEvent& evenement);
    void OnSize(wxSizeEvent& evenement);
	void OnMouseButton(wxMouseEvent& event);
	void OnMouseMotion(wxMouseEvent& event);
    void OnKeyDown(wxKeyEvent& evenement);
	void OnKeyUp(wxKeyEvent& evenement);
    void OnEnterWindow(wxMouseEvent& evenement) { SetFocus(); }
    void OnTimer(wxTimerEvent& event);
    Camera cam;

private:
	//Universe universe;
	bool simulationOn;
	set<Obj*> superTabObj;//sera vide car rien en dehors de l'univers
	set<ObjC*> superTabCharg;//idem
	System mainSys;
	
	int selectTool;
	
	bool mouseMod;
	bool stereoscopy;
	double compteurTimer;
	int xmouse;
	int ymouse;

    wxTimer* timer;// le "Timer"
    static int TIMER_ID;

DECLARE_EVENT_TABLE()
};
//---fenetre(s) principale(s)
class Fenetre: public wxFrame{
public:
  Fenetre(wxString const& titre, wxSize const& taille = wxDefaultSize, wxPoint const& position = wxDefaultPosition, long style = wxDEFAULT_FRAME_STYLE);
  virtual ~Fenetre() {}
protected:
  void OnExit(wxCommandEvent& event) { Close(true); }
  Vue_OpenGL* fogl;
DECLARE_EVENT_TABLE()
};

int Vue_OpenGL::TIMER_ID(12);
BEGIN_EVENT_TABLE(Vue_OpenGL, wxGLCanvas)
    EVT_PAINT(          Vue_OpenGL::dessine       )
    EVT_SIZE(           Vue_OpenGL::OnSize        )
	
	EVT_LEFT_DOWN( Vue_OpenGL::OnMouseButton)
	EVT_LEFT_UP( Vue_OpenGL::OnMouseButton)
	EVT_RIGHT_DOWN( Vue_OpenGL::OnMouseButton)
	EVT_RIGHT_UP( Vue_OpenGL::OnMouseButton)
	EVT_MIDDLE_DOWN( Vue_OpenGL::OnMouseButton)
	EVT_MIDDLE_UP( Vue_OpenGL::OnMouseButton)
	EVT_MOUSEWHEEL(Vue_OpenGL::OnMouseButton)
	EVT_MOTION( Vue_OpenGL::OnMouseMotion)
	
    EVT_KEY_DOWN(       Vue_OpenGL::OnKeyDown     )
	EVT_KEY_UP(       Vue_OpenGL::OnKeyUp     )
    EVT_ENTER_WINDOW(   Vue_OpenGL::OnEnterWindow )
    EVT_TIMER(TIMER_ID, Vue_OpenGL::OnTimer       )
END_EVENT_TABLE()

// ======================================================================
Vue_OpenGL::Vue_OpenGL(Fenetre* parent, wxSize const& taille, wxPoint const& position)
: wxGLCanvas(parent, wxID_ANY, position, taille, wxSUNKEN_BORDER|wxFULL_REPAINT_ON_RESIZE , wxT(""))
,parent(parent),mainSys(1,superTabObj, superTabCharg,Vect({0,0,0})),selectTool(0),mouseMod(false),stereoscopy(false),compteurTimer(0), timer(new wxTimer(this, TIMER_ID)){
	//universe.get().generate(Vect({0,0,0}),Vect({5,5,2}),1,100,0,false,0,true);
	srand(time(NULL)); // initialisation de rand
	vector<Obj*> temp;
	int iCOUNT=5;
	int jCOUNT=5;
	temp = mainSys.generate(Vect({0,0,0}),Vect({(double)iCOUNT,(double)jCOUNT,5}),1,100,0,100,false,0,false,false);
		//(*temp[0+0]).enableTranslationForce(false);
		(*temp[(size_t)iCOUNT-1+0]).enableTranslationForce(false);
		(*temp[0+((size_t)jCOUNT-1)*(size_t)iCOUNT]).enableTranslationForce(false);
		//(*temp[(size_t)iCOUNT-1+((size_t)jCOUNT-1)*(size_t)iCOUNT]).enableTranslationForce(false);
	//temp =mainSys.generate(Vect({0,0,0}),Vect({ (double) iCOUNT, (double) jCOUNT,2}),2.,10,0,25,false,0,false);
		//(*temp[0+0]).enableTranslationForce(false);
		//(*temp[(size_t)iCOUNT-1+0]).enableTranslationForce(false);
		//(*temp[0+((size_t)jCOUNT-1)*(size_t)iCOUNT]).enableTranslationForce(false);
		//(*temp[(size_t)iCOUNT-1+((size_t)jCOUNT-1)*(size_t)iCOUNT]).enableTranslationForce(false);
		
	//mainSys.addObj(Vect({0,0,5}),Vect({0,0,0}),10.,1,false);
	mainSys.addObj(Vect({0,0,-60000005}),Vect({0,0,0}),59000000000000000000000000.,/*60000000,true);*/0,true);
	//mainSys.addSpring(*(mainSys.addObj(Vect({8.,0,0}),Vect({0,0,0}),100.,1)),*(temp[iCOUNT-1]),100,2);
	//mainSys.generatePendulum(Vect(3),10,10,1);

	mainSys.frottement=.0;

	//(*mainSys.addObj(Vect({-10,-10,-10}),Vect({0,0,10}),10.,1,false)).setT(0);
	//mainSys.addObj(Vect({-5,-5,0}),5.9*pow(10,24),6400000,true);
	/*mainSys.addObj(Vect({-5,-5,0}),1000000,6,true);
	mainSys.addObj(Vect({-30,-30,0}),10,10,true);
	mainSys.addObj(Vect({-20,-5,0}),10,5,true);*/
	//mainSys.addObj(Vect({-5,-5,0}),10,1);
	//mainSys.add(0,{1,0,0},1,0,false,1);
}

// ======================================================================
void Vue_OpenGL::dessine(wxPaintEvent&){
	if (!GetContext()) return;
	SetCurrent();
	glClear(/*GL_COLOR_BUFFER_BIT | */GL_DEPTH_BUFFER_BIT);// pour le "flou"
	glMatrixMode(GL_MODELVIEW);//part du système de coordonnées de base
	glLoadIdentity();//(dessin à l'origine : matrice identité)

	cam.look();//place la caméra
	
	
	//---STEREO
	if(stereoscopy){
		cam.ApplyLeftFrustum();
		glColorMask(true, false, false, false);// bloque Green et Blue et Transparence
		//universe.disp();
		mainSys.disp();
		
		glClear(GL_DEPTH_BUFFER_BIT) ;
		
		cam.ApplyRightFrustum();
		glColorMask(false, true, true, false);//bloque Red et Transparence
		//universe.disp();
		mainSys.disp();
		
		glColorMask(true, true, true, true);
	}else {
		//universe.disp();
		mainSys.disp();
	}

	glFlush();
	SwapBuffers();
}

// ======================================================================
void Vue_OpenGL::OnSize(wxSizeEvent& event){
  wxGLCanvas::OnSize(event);// Nécessaire pour mettre à jour le contexte sur certaines plateformes
  if (GetContext()) {
    // set GL viewport (not called by wxGLCanvas::OnSize on all platforms...)
    int w, h;
    GetClientSize(&w, &h);
    SetCurrent();
    glViewport(0, 0, (GLint) w, (GLint) h);
  }
}

void Vue_OpenGL::OnMouseButton(wxMouseEvent& event){
	if (event.LeftIsDown()){
		switch (selectTool){
			case 0: break;
			case 1: break;
			case 2: break;
			case 3: break;
			case 4: break;
		}
	}
	if(event.m_wheelRotation!=0){
		//CHANGE OBJET
		selectTool+=event.m_wheelRotation / event.m_wheelDelta;
	}
	
}

void Vue_OpenGL::OnMouseMotion(wxMouseEvent& event){
	int xWin,yWin;GetSize(&xWin,&yWin);
	if (mouseMod&&(event.GetX()!=xWin/2 || event.GetY()!=yWin/2)){
		event.GetPosition(&xmouse,&ymouse);
		cam.RotateTheta((-ymouse+yWin/2)*4/(double)yWin);
		cam.RotatePhi((xmouse-xWin/2)*4/(double)xWin);
		cam.RotateRho((xmouse-xWin/2)*4/(double)xWin*-1);
		//wxGetMouseState().SetX(xWin/2);
		//glutWarpPointer(xWin / 2, yWin / 2);
		
		/*Display *dpy;
		dpy = XOpenDisplay (NULL);
		Window rootwindow;
		rootwindow = DefaultRootWindow (dpy);
		XWarpPointer (dpy, rootwindow, rootwindow, 0, 0, 0, 0, xWin/2, yWin/2);*/
		//XWarpPointer(xWin/2, yWin/2);
	}else{
		cam.RotateTheta(0);
		cam.RotatePhi(0);
		cam.RotateRho(0);
	}
	//DoCaptureMouse();
	//CaptureMouse();
	//wxGetMouseState().SetX(xWin/2);
	
	//WarpPointer(5, 5);
}

//Key Listener
void Vue_OpenGL::OnKeyUp( wxKeyEvent& event ){
	if(event.GetKeyCode()=='W')			cam.walk(0);
	else if(event.GetKeyCode()=='S')	cam.walk(0);
	else if(event.GetKeyCode()=='A')	{cam.strafe(0);cam.RotateRho(0);}
	else if(event.GetKeyCode()=='D')	{cam.strafe(0);cam.RotateRho(0);}
	else if(event.GetKeyCode()=='E')	cam.jump(0);
	else if(event.GetKeyCode()=='Q')	cam.jump(0);
	else if(event.GetKeyCode()=='O')	cam.focusMove(0);
	else if(event.GetKeyCode()=='U')	cam.focusMove(0);
	else if(event.GetKeyCode()=='K')	cam.perspectiveMove(0);
	else if(event.GetKeyCode()=='L')	cam.perspectiveMove(0);
	else if(event.GetKeyCode()=='N')	cam.motionBlurMove(0);
	else if(event.GetKeyCode()=='B')	cam.motionBlurMove(0);
	else if(event.GetKeyCode()==WXK_LEFT)		{cam.RotatePhi(0);cam.RotateRho(0);}
	else if(event.GetKeyCode()==WXK_RIGHT)		{cam.RotatePhi(0);cam.RotateRho(0);}
	else if(event.GetKeyCode()==WXK_UP)			cam.RotateTheta(0);
	else if(event.GetKeyCode()==WXK_DOWN)		cam.RotateTheta(0);
	else if(event.GetKeyCode()==WXK_PAGEUP)			cam.RotateRho(0);
	else if(event.GetKeyCode()==WXK_PAGEDOWN)	cam.RotateRho(0);
}
void Vue_OpenGL::OnKeyDown( wxKeyEvent& event ){
	if(event.ShiftDown())cam.fast=10;//	bug, a ameliorer
		else cam.fast=1;
	if(event.GetKeyCode()=='W')			cam.walk(-1);
	else if(event.GetKeyCode()=='S')	cam.walk(1);
	else if(event.GetKeyCode()=='A')	{cam.strafe(-1);if(event.ShiftDown())cam.RotateRho(-.5);}
	else if(event.GetKeyCode()=='D')	{cam.strafe(1);if(event.ShiftDown())cam.RotateRho(.5);}
	else if(event.GetKeyCode()=='E')	cam.jump(-1);
	else if(event.GetKeyCode()=='Q')	cam.jump(1);
	else if(event.GetKeyCode()==WXK_TAB)	cam.showTerminal=!cam.showTerminal;
	else if(event.ControlDown() && event.GetKeyCode()=='U')	cam.focusMove(.0005);
	else if(event.ControlDown() && event.GetKeyCode()=='O')	cam.focusMove(-.0005);
	else if(event.ControlDown() && event.GetKeyCode()=='I')	stereoscopy=!stereoscopy;
	else if(event.ControlDown() && event.GetKeyCode()=='K')	cam.perspectiveMove(.01);
	else if(event.ControlDown() && event.GetKeyCode()=='L')	cam.perspectiveMove(-.01);
	else if(event.ControlDown() && event.GetKeyCode()=='J')	cam.showBoussole=((cam.showBoussole+1)%3);
	else if(event.ControlDown() && event.GetKeyCode()=='F') if((*parent).IsFullScreen())(*parent).ShowFullScreen(false,wxFULLSCREEN_ALL);
		else (*parent).ShowFullScreen(true,wxFULLSCREEN_ALL);
	else if(event.ControlDown() && event.GetKeyCode()=='M')	{mouseMod= !mouseMod; if(mouseMod)CaptureMouse();else ReleaseMouse();}
	else if(event.ControlDown() && event.GetKeyCode()=='B')	cam.motionBlurMove(.005);
	else if(event.ControlDown() && event.GetKeyCode()=='N')	cam.motionBlurMove(-.005);
	else if(event.ControlDown() && event.GetKeyCode()=='P')	simulationOn=!simulationOn;
	else if(event.GetKeyCode()==WXK_LEFT)		{cam.RotatePhi( -1);cam.RotateRho(1);}
	else if(event.GetKeyCode()==WXK_RIGHT)		{cam.RotatePhi(1);cam.RotateRho(-1);}
	else if(event.GetKeyCode()==WXK_UP)			cam.RotateTheta(1);
	else if(event.GetKeyCode()==WXK_DOWN)		cam.RotateTheta(-1);
	else if(event.GetKeyCode()==WXK_PAGEUP)			cam.RotateRho(-2);
	else if(event.GetKeyCode()==WXK_PAGEDOWN)	cam.RotateRho(2);
	/*timer->Stop();
	timer->Start();*/
  event.Skip();
}

// ======================================================================
void Vue_OpenGL::InitOpenGL(){
	SetCurrent();// Initialisation OpenGL
	glEnable(GL_DEPTH_TEST);// active la gestion de la profondeur
	glEnable (GL_BLEND);// active la transparence
	glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	SetCursor(*wxCROSS_CURSOR);
	
	glClearColor(0.03, 0.16, 0.18, 0.0);
	
	timer->Start(20);// lance le Timer
}

//! TIMER !!!
void Vue_OpenGL::OnTimer(wxTimerEvent& event){
	
	compteurTimer+=event.GetInterval();
	if(compteurTimer > 10){
		if(simulationOn)mainSys.update(.045);//event.GetInterval()/500.);
		compteurTimer=0;
	}
	
	cam.update(event.GetInterval());
	// demande l'affichage
	Refresh(false);
}


//---Implementation de Fenetre
BEGIN_EVENT_TABLE(Fenetre, wxFrame)
    EVT_MENU( wxID_EXIT, Fenetre::OnExit )
END_EVENT_TABLE()

// ======================================================================
Fenetre::Fenetre( wxString const& titre, wxSize const& taille, wxPoint const& position, long style): wxFrame(0, wxID_ANY, titre, position, taille, style), fogl(new Vue_OpenGL(this)){
    // Barre de menu
    /*wxMenu* winMenu = new wxMenu;    winMenu->Append(wxID_EXIT, wxT("&Close"));
    wxMenuBar* menuBar = new wxMenuBar;    menuBar->Append(winMenu, wxT("&Window"));
    SetMenuBar(menuBar);*/
	ShowFullScreen(true,wxFULLSCREEN_ALL);
	Centre();
    Show(true);// montre la fenetre
    fogl->InitOpenGL();// Initialise OpenGL
}

//---Implementation de l'application principale
bool GUI::OnInit(){
  // Crée la fenêtre principale
  Fenetre* f = new Fenetre(wxT("Projet Informatique MaPh 2011-2012"), wxSize(800, 600));
  SetTopWindow(f);
  return (f != 0);
}

IMPLEMENT_APP(GUI)//Equivalent de main()


