#include "Universe.h"
#include "Camera.h"
/*
#include "wx/wxprec.h"
#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif
#include "wx/glcanvas.h" // Pour combiner wxWidgets et OpenGL
*/
class Fenetre;
class GUI : public wxApp{public:bool OnInit();};//---Nouvelle application

//---sous-fenetre de dessin OpenGL
class Vue_OpenGL : public wxGLCanvas{
public:
    Vue_OpenGL(Fenetre* parent, wxSize const& taille = wxDefaultSize, wxPoint const& position = wxDefaultPosition);
    virtual ~Vue_OpenGL() {gluDeleteQuadric(sphere);}

    void InitOpenGL();

protected:
	Fenetre* parent;
    void dessine(wxPaintEvent& evenement);
    void OnSize(wxSizeEvent& evenement);
	void OnMouseButton(wxMouseEvent& event);
	void OnMouseMotion(wxMouseEvent& event);
    void OnKeyDown(wxKeyEvent& evenement);
	void OnKeyUp(wxKeyEvent& evenement);
    void OnEnterWindow(wxMouseEvent& evenement) { SetFocus(); }
    void OnTimer(wxTimerEvent& event);
    Camera cam;

private:
	bool simulationOn;
	set<Obj*> superTabObj;//sera vide car rien en dehors de l'univers
	set<ObjC*> superTabCharg;//idem
	System mainSys;
	
	int selectTool;
	
	bool mouseMod;
	bool stereoscopy;
	double compteurTimer;
	int xmouse;
	int ymouse;
    GLUquadric* sphere;

    wxTimer* timer;// le "Timer"
    static int TIMER_ID;

DECLARE_EVENT_TABLE()
};
//---fenetre(s) principale(s)
class Fenetre: public wxFrame{
public:
  Fenetre(wxString const& titre, wxSize const& taille = wxDefaultSize, wxPoint const& position = wxDefaultPosition, long style = wxDEFAULT_FRAME_STYLE);
  virtual ~Fenetre() {}
protected:
  void OnExit(wxCommandEvent& event) { Close(true); }
  Vue_OpenGL* fogl;
DECLARE_EVENT_TABLE()
};

int Vue_OpenGL::TIMER_ID(12);
BEGIN_EVENT_TABLE(Vue_OpenGL, wxGLCanvas)
    EVT_PAINT(          Vue_OpenGL::dessine       )
    EVT_SIZE(           Vue_OpenGL::OnSize        )
	
	EVT_LEFT_DOWN( Vue_OpenGL::OnMouseButton)
	EVT_LEFT_UP( Vue_OpenGL::OnMouseButton)
	EVT_RIGHT_DOWN( Vue_OpenGL::OnMouseButton)
	EVT_RIGHT_UP( Vue_OpenGL::OnMouseButton)
	EVT_MIDDLE_DOWN( Vue_OpenGL::OnMouseButton)
	EVT_MIDDLE_UP( Vue_OpenGL::OnMouseButton)
	EVT_MOUSEWHEEL(Vue_OpenGL::OnMouseButton)
	EVT_MOTION( Vue_OpenGL::OnMouseMotion)
	
    EVT_KEY_DOWN(       Vue_OpenGL::OnKeyDown     )
	EVT_KEY_UP(       Vue_OpenGL::OnKeyUp     )
    EVT_ENTER_WINDOW(   Vue_OpenGL::OnEnterWindow )
    EVT_TIMER(TIMER_ID, Vue_OpenGL::OnTimer       )
END_EVENT_TABLE()

//POUR LE TEST

vector<Obj*> ptrtrace;
vector<vector<Vect> > traj;

// ======================================================================
Vue_OpenGL::Vue_OpenGL(Fenetre* parent, wxSize const& taille, wxPoint const& position)
: wxGLCanvas(parent, wxID_ANY, position, taille, wxSUNKEN_BORDER|wxFULL_REPAINT_ON_RESIZE , wxT(""))
,parent(parent),mainSys(1,superTabObj, superTabCharg,Vect({0,0,0})),selectTool(0),mouseMod(false),stereoscopy(false),compteurTimer(0),sphere(gluNewQuadric()), timer(new wxTimer(this, TIMER_ID)){
	//universe.get().generate(Vect({0,0,0}),Vect({5,5,2}),1,100,0,false,0,true);
	srand(time(NULL)); // initialisation de rand
	

	//ptr001=(mainSys.addObj(Vect({3,-3,0}),Vect({0,5,5}),10.,.5,false));
	/*ptrtrace.push_back( mainSys.generatePendulum(Vect({50,20,0}),10,10,1) );
	(*ptrtrace[ptrtrace.size()-1]).setdx({0,1,0});
	traj.push_back({});
	ptrtrace.push_back( (mainSys.generatePendulum2(Vect({50,0,0}),10,10,1))[0] );
	(*ptrtrace[ptrtrace.size()-1]).setdx({0,50,0});
	traj.push_back({});
	ptrtrace.push_back( (mainSys.generatePendulum2(Vect({70,0,0}),10,10,1))[0] );
	(*ptrtrace[ptrtrace.size()-1]).setdx({0,30,30});
	traj.push_back({});
	ptrtrace.push_back( (mainSys.generatePendulum2(Vect({90,0,0}),10,10,1))[5] );
	(*ptrtrace[ptrtrace.size()-1]).setdx({0,30,30});
	traj.push_back({});
	//ptr003=(mainSys.generatePendulum3(Vect({50,-20,0}),10,10,1))[0];
	//(*ptr003).setdx({0,50,0});
	ptrtrace.push_back( mainSys.generatePendulum(Vect({50,-20,0}),10,8,1) );
	(*ptrtrace[ptrtrace.size()-1]).setdx({-30,-20,-50});
	traj.push_back({});
	ptrtrace.push_back( mainSys.generatePendulum(Vect({50,-20,0}),10,10,1) );
	(*ptrtrace[ptrtrace.size()-1]).setdx({0,10,10});
	traj.push_back({});*/

	for(int i=0;i<10;i++){
		for(int j=0;j<10;j++){
			ptrtrace.push_back( mainSys.generatePendulum(Vect({50+i*30.,j*20.,0}),10,10,0) );
			(*ptrtrace[ptrtrace.size()-1]).setdx({0,i*1.,j*1.});
			traj.push_back({});
		}
	}

	//ptrtrace.push_back( mainSys.generatePendulum(Vect({50,-40,0}),10,10,1) );
	//(*ptrtrace[ptrtrace.size()-1]).setdx({0,3,4});
	mainSys.addObj(Vect({0,0,-60000005}),Vect({0,0,0}),59000000000000000000000000.,0,true);// un champ gravitaionnel
	mainSys.frottement=.005;
}

// ======================================================================
void Vue_OpenGL::dessine(wxPaintEvent&){
	if (!GetContext()) return;
	SetCurrent();
	glClear(/*GL_COLOR_BUFFER_BIT | */GL_DEPTH_BUFFER_BIT);// pour le "flou"
	glMatrixMode(GL_MODELVIEW);//part du système de coordonnées de base
	glLoadIdentity();//(dessin à l'origine : matrice identité)

	

	cam.look();//place la caméra
	
	string strInstruction;
			strInstruction+="bienvenue dans le test de Pendule-Ressort !---------------------------------------------------------------------------------------------------------------------------------------------------------------------";
			strInstruction+="\n-->> press CTRL+P to activate physics ! <<--        -->> press CTRL+P to activate physics ! <<--       -->> press CTRL+P to activate physics ! <<--       -->> press CTRL+P to activate physics ! <<--        ";
			strInstruction+="\nthen press SPACE for fun ! :-)                                                                                                                                                                             :-D ";
			strInstruction+="\nmove with wasd and arrows--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------";
			strInstruction+="\n\nchanger mainSys.disp() en mainSys.cdisp() dans testBalle.cc dans la fonction dessine pour le terminal, la fenetre s'ouvre quand meme, regarder dans le terminal apres avoir active la simulation dans la fenetre!";
			strInstruction+="\n-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------";

	//---STEREO
	if(stereoscopy){
		cam.ApplyLeftFrustum();
		glColorMask(true, false, false, false);// bloque Green et Blue et Transparence
		mainSys.disp();

					glLineWidth(2.);
					glPointSize(2.);
					glColor4d(0.5,1.,1.,1);
					
					for(int i=0;i<traj.size();i++){
						glBegin(GL_LINE_STRIP);
						for(size_t j=0;j<traj[i].size();j++){
								glVertex3d(traj[i][j].get(0),traj[i][j].get(1),traj[i][j].get(2));
						}
						glEnd();
					}

		
			glLineWidth(2.);
			glPointSize(2.);
			glColor4d(0.5,1.,1.,1);
			String3d(strInstruction,0,0).disp();

		glClear(GL_DEPTH_BUFFER_BIT) ;
		
		cam.ApplyRightFrustum();
		glColorMask(false, true, true, false);//bloque Red et Transparence
		mainSys.disp();

					glLineWidth(2.);
					glPointSize(2.);
					glColor4d(0.5,1.,1.,1);
					for(int i=0;i<traj.size();i++){
						glBegin(GL_LINE_STRIP);
						for(size_t j=0;j<traj[i].size();j++){
								glVertex3d(traj[i][j].get(0),traj[i][j].get(1),traj[i][j].get(2));
						}
						glEnd();
					}

			glLineWidth(2.);
			glPointSize(2.);
			glColor4d(0.5,1.,1.,1);
			String3d(strInstruction,0,0).disp();
		
		glColorMask(true, true, true, true);
	}else {
		mainSys.disp();

					glLineWidth(2.);
					glPointSize(2.);
					glColor4d(0.5,1.,1.,1);
					for(int i=0;i<traj.size();i++){
						glBegin(GL_LINE_STRIP);
						for(size_t j=0;j<traj[i].size();j++){
								glVertex3d(traj[i][j].get(0),traj[i][j].get(1),traj[i][j].get(2));
						}
						glEnd();
					}

		glLineWidth(2.);
		glPointSize(2.);
		glColor4d(0.5,1.,1.,1);
		String3d(strInstruction,0,0).disp();
	}

	glFlush();
	SwapBuffers();
}

// ======================================================================
void Vue_OpenGL::OnSize(wxSizeEvent& event){
  wxGLCanvas::OnSize(event);// Nécessaire pour mettre à jour le contexte sur certaines plateformes
  if (GetContext()) {
    // set GL viewport (not called by wxGLCanvas::OnSize on all platforms...)
    int w, h;
    GetClientSize(&w, &h);
    SetCurrent();
    glViewport(0, 0, (GLint) w, (GLint) h);
  }
}

void Vue_OpenGL::OnMouseButton(wxMouseEvent& event){
	if (event.LeftIsDown()){
		switch (selectTool){
			case 0: break;
			case 1: break;
			case 2: break;
			case 3: break;
			case 4: break;
		}
	}
	if(event.m_wheelRotation!=0){
		//CHANGE OBJET
		selectTool+=event.m_wheelRotation / event.m_wheelDelta;
	}
	
}

void Vue_OpenGL::OnMouseMotion(wxMouseEvent& event){
	int xWin,yWin;GetSize(&xWin,&yWin);
	if (mouseMod&&(event.GetX()!=xWin/2 || event.GetY()!=yWin/2)){
		event.GetPosition(&xmouse,&ymouse);
		cam.RotateTheta((-ymouse+yWin/2)*4/(double)yWin);
		cam.RotatePhi((xmouse-xWin/2)*4/(double)xWin);
		cam.RotateRho((xmouse-xWin/2)*4/(double)xWin*-1);
		//wxGetMouseState().SetX(xWin/2);
		//glutWarpPointer(xWin / 2, yWin / 2);
		
		/*Display *dpy;
		dpy = XOpenDisplay (NULL);
		Window rootwindow;
		rootwindow = DefaultRootWindow (dpy);
		XWarpPointer (dpy, rootwindow, rootwindow, 0, 0, 0, 0, xWin/2, yWin/2);*/
		//XWarpPointer(xWin/2, yWin/2);
	}else{
		cam.RotateTheta(0);
		cam.RotatePhi(0);
		cam.RotateRho(0);
	}
	//DoCaptureMouse();
	//CaptureMouse();
	//wxGetMouseState().SetX(xWin/2);
	
	//WarpPointer(5, 5);
}

//Key Listener
void Vue_OpenGL::OnKeyUp( wxKeyEvent& event ){
	if(event.GetKeyCode()=='W')			cam.walk(0);
	else if(event.GetKeyCode()=='S')	cam.walk(0);
	else if(event.GetKeyCode()=='A')	{cam.strafe(0);cam.RotateRho(0);}
	else if(event.GetKeyCode()=='D')	{cam.strafe(0);cam.RotateRho(0);}
	else if(event.GetKeyCode()=='E')	cam.jump(0);
	else if(event.GetKeyCode()=='Q')	cam.jump(0);
	else if(event.GetKeyCode()=='O')	cam.focusMove(0);
	else if(event.GetKeyCode()=='U')	cam.focusMove(0);
	else if(event.GetKeyCode()=='K')	cam.perspectiveMove(0);
	else if(event.GetKeyCode()=='L')	cam.perspectiveMove(0);
	else if(event.GetKeyCode()=='N')	cam.motionBlurMove(0);
	else if(event.GetKeyCode()=='B')	cam.motionBlurMove(0);
	else if(event.GetKeyCode()==WXK_LEFT)		{cam.RotatePhi(0);cam.RotateRho(0);}
	else if(event.GetKeyCode()==WXK_RIGHT)		{cam.RotatePhi(0);cam.RotateRho(0);}
	else if(event.GetKeyCode()==WXK_UP)			cam.RotateTheta(0);
	else if(event.GetKeyCode()==WXK_DOWN)		cam.RotateTheta(0);
	else if(event.GetKeyCode()==WXK_PAGEUP)			cam.RotateRho(0);
	else if(event.GetKeyCode()==WXK_PAGEDOWN)	cam.RotateRho(0);
}
void Vue_OpenGL::OnKeyDown( wxKeyEvent& event ){
	if(event.ShiftDown())cam.fast=10;//	bug, a ameliorer
		else cam.fast=1;
	if(event.GetKeyCode()=='W')			cam.walk(-1);
	else if(event.GetKeyCode()=='S')	cam.walk(1);
	else if(event.GetKeyCode()=='A')	{cam.strafe(-1);if(event.ShiftDown())cam.RotateRho(-.5);}
	else if(event.GetKeyCode()=='D')	{cam.strafe(1);if(event.ShiftDown())cam.RotateRho(.5);}
	else if(event.GetKeyCode()=='E')	cam.jump(-1);
	else if(event.GetKeyCode()=='Q')	cam.jump(1);
	else if(event.GetKeyCode()==WXK_TAB)	cam.showTerminal=!cam.showTerminal;
	else if(event.ControlDown() && event.GetKeyCode()=='U')	cam.focusMove(.0005);
	else if(event.ControlDown() && event.GetKeyCode()=='O')	cam.focusMove(-.0005);
	else if(event.ControlDown() && event.GetKeyCode()=='I')	stereoscopy=!stereoscopy;
	else if(event.ControlDown() && event.GetKeyCode()=='K')	cam.perspectiveMove(.01);
	else if(event.ControlDown() && event.GetKeyCode()=='L')	cam.perspectiveMove(-.01);
	else if(event.ControlDown() && event.GetKeyCode()=='J')	cam.showBoussole=((cam.showBoussole+1)%3);
	else if(event.ControlDown() && event.GetKeyCode()=='F') if((*parent).IsFullScreen())(*parent).ShowFullScreen(false,wxFULLSCREEN_ALL);
		else (*parent).ShowFullScreen(true,wxFULLSCREEN_ALL);
	else if(event.ControlDown() && event.GetKeyCode()=='M')	{mouseMod= !mouseMod; if(mouseMod)CaptureMouse();else ReleaseMouse();}
	else if(event.ControlDown() && event.GetKeyCode()=='B')	cam.motionBlurMove(.005);
	else if(event.ControlDown() && event.GetKeyCode()=='N')	cam.motionBlurMove(-.005);
	else if(event.ControlDown() && event.GetKeyCode()=='P')	simulationOn=!simulationOn;
	else if(event.GetKeyCode()==WXK_LEFT)		{cam.RotatePhi( -1);cam.RotateRho(1);}
	else if(event.GetKeyCode()==WXK_RIGHT)		{cam.RotatePhi(1);cam.RotateRho(-1);}
	else if(event.GetKeyCode()==WXK_UP)			cam.RotateTheta(1);
	else if(event.GetKeyCode()==WXK_DOWN)		cam.RotateTheta(-1);
	else if(event.GetKeyCode()==WXK_PAGEUP)			cam.RotateRho(-2);
	else if(event.GetKeyCode()==WXK_PAGEDOWN)	cam.RotateRho(2);
	else if(event.GetKeyCode()==' '){
		for(int i=0;i<25;i++){
			mainSys.addObj(Vect({3,0,0}),randVect(5,3),10.,0,false);
			mainSys.addObj(Vect({3,0,0}),randVect(10,3),10.,0,false);
			mainSys.addObj(Vect({3,0,0}),randVect(20,3),10.,0,false);
		}
	}
	/*timer->Stop();
	timer->Start();*/
  event.Skip();
}

// ======================================================================
void Vue_OpenGL::InitOpenGL(){
	SetCurrent();// Initialisation OpenGL
	glEnable(GL_DEPTH_TEST);// active la gestion de la profondeur
	glEnable (GL_BLEND);// active la transparence
	glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	SetCursor(*wxCROSS_CURSOR);
	
	glClearColor(0.03, 0.16, 0.18, 0.0);
	
	timer->Start(20);// lance le Timer
}

//! TIMER !!!
void Vue_OpenGL::OnTimer(wxTimerEvent& event){
	
	compteurTimer+=event.GetInterval();
	if(compteurTimer > 10){
		if(simulationOn){
			mainSys.update(.045);
			//event.GetInterval()/500.);
			for(int i=0;i<ptrtrace.size();i++){
				traj[i].push_back((*ptrtrace[i]).getX());
			}
		}
		compteurTimer=0;

	}
	cam.update(event.GetInterval());
	// demande l'affichage
	Refresh(false);
}


//---Implementation de Fenetre
BEGIN_EVENT_TABLE(Fenetre, wxFrame)
    EVT_MENU( wxID_EXIT, Fenetre::OnExit )
END_EVENT_TABLE()

// ======================================================================
Fenetre::Fenetre( wxString const& titre, wxSize const& taille, wxPoint const& position, long style): wxFrame(0, wxID_ANY, titre, position, taille, style), fogl(new Vue_OpenGL(this)){
    // Barre de menu
    /*wxMenu* winMenu = new wxMenu;    winMenu->Append(wxID_EXIT, wxT("&Close"));
    wxMenuBar* menuBar = new wxMenuBar;    menuBar->Append(winMenu, wxT("&Window"));
    SetMenuBar(menuBar);*/
	ShowFullScreen(true,wxFULLSCREEN_ALL);
	Centre();
    Show(true);// montre la fenetre
    fogl->InitOpenGL();// Initialise OpenGL
}

//---Implementation de l'application principale
bool GUI::OnInit(){
  // Crée la fenêtre principale
  Fenetre* f = new Fenetre(wxT("Projet Informatique MaPh 2011-2012"), wxSize(800, 600));
  SetTopWindow(f);
  return (f != 0);
}

IMPLEMENT_APP(GUI)//Equivalent de main()


